package com.yolo.keyboard.service.tag;

import java.util.*;

import com.yolo.keyboard.dal.dataobject.tag.TagI18nDO;
import jakarta.validation.*;
import com.yolo.keyboard.controller.admin.tag.vo.*;
import com.yolo.keyboard.dal.dataobject.tag.KeyboardTagDO;
import com.yolo.keyboard.framework.common.pojo.PageResult;
import com.yolo.keyboard.framework.common.pojo.PageParam;

/**
 * 人设标签 Service 接口
 *
 * @author ziin
 */
public interface KeyboardTagService {

    /**
     * 创建人设标签
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    Integer createTag(@Valid KeyboardTagSaveReqVO createReqVO);

    /**
     * 更新人设标签
     *
     * @param updateReqVO 更新信息
     */
    void updateTag(@Valid KeyboardTagSaveReqVO updateReqVO);

    /**
     * 删除人设标签
     *
     * @param id 编号
     */
    void deleteTag(Integer id);

    /**
    * 批量删除人设标签
    *
    * @param ids 编号
    */
    void deleteTagListByIds(List<Integer> ids);

    /**
     * 获得人设标签
     *
     * @param id 编号
     * @return 人设标签
     */
    KeyboardTagDO getTag(Integer id);

    /**
     * 获得人设标签分页
     *
     * @param pageReqVO 分页查询
     * @return 人设标签分页
     */
    PageResult<KeyboardTagDO> getTagPage(KeyboardTagPageReqVO pageReqVO);
    // ==================== 子表（人设标签国际化） ====================

    /**
     * 获得人设标签国际化分页
     *
     * @param pageReqVO 分页查询
     * @param tagId 标签主表ID，对应 keyboard_tag.id
     * @return 人设标签国际化分页
     */
    PageResult<TagI18nDO> getTagI18nPage(PageParam pageReqVO, Integer tagId);

    /**
     * 创建人设标签国际化
     *
     * @param tagI18n 创建信息
     * @return 编号
     */
    Long createTagI18n(@Valid TagI18nDO tagI18n);

    /**
     * 更新人设标签国际化
     *
     * @param tagI18n 更新信息
     */
    void updateTagI18n(@Valid TagI18nDO tagI18n);

    /**
     * 删除人设标签国际化
     *
     * @param id 编号
     */
    void deleteTagI18n(Long id);

    /**
     * 批量删除人设标签国际化
     *
     * @param ids 编号
     */
    void deleteTagI18nListByIds(List<Long> ids);

    /**
     * 获得人设标签国际化
     *
     * @param id 编号
     * @return 人设标签国际化
     */
    TagI18nDO getTagI18n(Long id);
}